# Node / Express / MongoDB demo

This example repository demonstrates how to set up a simple backend
server and implementing an API to store data in a MongoDB database.

## Requirements

This demo requires setting up a Goldsmiths virtual machine running
Ubuntu Linux 20.04.

**It turns out there isn't enough disk space given to student VM's to
install MongoDb!** 

I'll ask if that can be changed, but you can try out this demo on your
laptops too if you can install `node.js` and `mongodb`.

- [`node.js`](https://nodejs.org/en/)

`node.js` and `npm` (bundled with `node.js` from the official
distribution) must first be installed on the system before building
and running this demo. For running the backend on a Goldsmiths VM
follow the instructions for installing on [Ubuntu Linux 20.04
](https://github.com/nodesource/distributions#ubuntu-versions).

- [`MongoDB`](https://www.mongodb.com/)

For running the backend on a Goldsmiths follow the instructions for
installing on [Ubuntu Linux
20.04](https://www.mongodb.com/docs/manual/tutorial/install-mongodb-on-ubuntu/).

- [Postman](https://www.postman.com) is a very useful tool for
  developing and testing a backend API. The postman app can be
  downloaded and installed on your laptop or ran from a web browser.


## Installation

Log into your VM and clone the repository in your home directory,
either using `HTTPS` or `SSH` (if you have set up your `SSH key` and
have enabled the `ForwardAgent yes` config option).

```
# HTTPS
git clone https://gitlab.doc.gold.ac.uk/cc-project-demos/demo-node-express-mongodb.git
```

```
# SSH
git clone git@gitlab.doc.gold.ac.uk:cc-project-demos/demo-node-express-mongodb.git
```

Then install the project inside the repository.

```
cd demo-node-express-mongodb
npm install
```

Set up your environment variables by creating an `.env` file in the
root of the repository. `.env` files should usually not be checked
into `git` because they typically contain machine-specific run-time
settings, and may even include sensitive information such as
passwords and API keys, which must be kept secure.
```
MONGO_URI=mongodb://127.0.0.1:27017/book_database
PORT=8000
```

## Running in developer mode

```
npm run dev
```

## Running in non-developer mode

```
npm run start
```

## Testing your backend with `postman`

If you are testing your backend on your laptop and you also have the
`postman` app installed, you can test your backed by sending HTTP
`GET`, `PUSH` and `DELETE` requests to `localhost:8000/books/`.

If you have deployed your backend on a Goldsmiths VM, using port 8000,
your public URL will be something like this:

- https://www.doc.gold.ac.uk/usr/???/books/

You will need to replace `???` with the ID of your server.
