const express = require('express');
const router = express.Router();
let { getAllBooks, getBookById, addBook, removeBook } = require('../controllers/bookController')


router.get('/', async (req, res) => {
    let response = await getAllBooks(req.query.author, req.query.title);
    if (response.success == true) {
        res.status(200).json(response);
    } else {
        res.status(404).json(response);
    }
});

router.get('/:id', async (req, res) => {
    let response = await getBookById(req.params.id);
    res.json(response);
});

router.post('/', async (req, res) => {
    console.log(req.body);
    let body = {
        author: req.body.author,
        title: req.body.title,
    };
    let response = await addBook(body);

    if (response.success == true) {
        res.status(201).json(response);
    } else {
        res.status(404).json(response);
    }
});

router.delete('/:id', async (req, res) => {
    let response = await removeBook(req.params.id)
    try {
        res.status(200).json(response);
    } catch (err) {
        res.status(500).json(response);
    }
});

module.exports = router;
