const express = require('express');
const connectDb = require('./config/db');
const books = require('./routes/books')

// Create an express app.
const app = express();

// Enable JSON parsing middleware.
app.use(express.json());

// Test the express server.
// app.get('/', (req, res) => {
//   res.send('Hello World!')
// });

// Connect to MongoDB.
connectDb();

// Enable books routes.
app.use('/books', books);

// Start server.
app.listen(process.env.PORT || 8000, () => console.log('Server started'))
